Index: /trunk/contactcenter/setup/tables_current.inc.php
===================================================================
--- /trunk/contactcenter/setup/tables_current.inc.php	(revision 3282)
+++ /trunk/contactcenter/setup/tables_current.inc.php	(revision 5131)
@@ -288,5 +288,8 @@
 				'notes'			=> array( 'type' => 'text' ),
 				'is_global'		=> array( 'type' => 'bool' ),
-				'corporate_name'=> array( 'type' => 'varchar', 'precision' => 100)
+				'corporate_name'=> array( 'type' => 'varchar', 'precision' => 100),
+				'web_page'=> array( 'type' => 'varchar', 'precision' => 100),
+				'job_title'=> array( 'type' => 'varchar', 'precision' => 40),
+				'department'=> array( 'type' => 'varchar', 'precision' => 30)
 			),
 			'pk' => array('id_contact'),
Index: /trunk/contactcenter/setup/tables_update.inc.php
===================================================================
--- /trunk/contactcenter/setup/tables_update.inc.php	(revision 4306)
+++ /trunk/contactcenter/setup/tables_update.inc.php	(revision 5131)
@@ -65,3 +65,15 @@
  	    return $GLOBALS['setup_info']['contactcenter']['currentver']; 
  	}
+	
+	$test[] = '2.2.3'; 
+ 	function contactcenter_upgrade2_2_3() { 
+		$GLOBALS['phpgw_setup']->db->query("ALTER TABLE phpgw_cc_contact ALTER COLUMN alias TYPE character varying(100);");
+ 	    $GLOBALS['setup_info']['contactcenter']['currentver'] = '2.2.3.1';
+		return $GLOBALS['setup_info']['contactcenter']['currentver']; 
+ 	}
+	$test[] = '2.2.3.1'; 
+ 	function contactcenter_upgrade2_2_3_1() { 
+ 	    $GLOBALS['setup_info']['contactcenter']['currentver'] = '2.4.0';
+		return $GLOBALS['setup_info']['contactcenter']['currentver']; 
+ 	}
 ?>
Index: /trunk/contactcenter/setup/setup.inc.php
===================================================================
--- /trunk/contactcenter/setup/setup.inc.php	(revision 4306)
+++ /trunk/contactcenter/setup/setup.inc.php	(revision 5131)
@@ -17,5 +17,5 @@
 	$setup_info['contactcenter']['name']      = 'contactcenter';
 	$setup_info['contactcenter']['title']     = 'ContactCenter';
-	$setup_info['contactcenter']['version']   = '2.2.2';
+	$setup_info['contactcenter']['version']   = '2.4.0';
 	$setup_info['contactcenter']['app_order'] = 4;
 	$setup_info['contactcenter']['enable']    = 1;
@@ -76,5 +76,5 @@
 	$setup_info['contactcenter']['depends'][] = array(
 		'appname' => 'phpgwapi',
-		'versions' => Array('2.2')
+		'versions' => Array('2.4.0')
 	);
 ?>
Index: /trunk/contactcenter/inc/class.so_group.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.so_group.inc.php	(revision 4754)
+++ /trunk/contactcenter/inc/class.so_group.inc.php	(revision 5131)
@@ -93,4 +93,40 @@
 		}
 		
+                function touchContacts( $pContacts )
+                {
+                   
+                    $qSelect =  'SELECT A.id_contact from phpgw_cc_contact A,'.
+                                'phpgw_cc_contact_conns B WHERE '.
+                                'A.id_contact = B.id_contact and B.id_connection in('.implode( ',' , $pContacts ).')';
+                    
+                    
+                    $qUpdate = 'UPDATE phpgw_cc_contact '.
+                               'SET last_status = \'U\', last_update = \''.time().'000\' '.
+                               'WHERE id_contact IN( '.$qSelect.' )';   
+                    
+                      if (!$this->db->query($qUpdate))
+                        exit ('Query failed! File: '.__FILE__.' on line'.__LINE__);
+                }
+                
+                function touchContactsByGroup ( $pIdGroup )
+                {
+                    $qSelect = 'SELECT A.id_contact from phpgw_cc_contact A,'.
+			'phpgw_cc_contact_conns B, phpgw_cc_connections C,phpgw_cc_contact_grps D where '.
+			'A.id_contact = B.id_contact and B.id_connection = C.id_connection '.
+			' and '.
+			' D.id_connection = C.id_connection and D.id_group = '.$pIdGroup;
+
+                    
+                    $qUpdate = 'UPDATE phpgw_cc_contact '.
+                             'SET last_status = \'U\', last_update = \''.time().'000\' '.
+                             'WHERE id_contact IN( '.$qSelect.' )';   
+   
+
+                    if (!$this->db->query($qUpdate))
+			exit ('Query failed! File: '.__FILE__.' on line'.__LINE__);
+			
+                    
+                }
+                
 		function delete($data)
 		{
@@ -423,74 +459,4 @@
 		}
 
-		function verifyContact($email, $name, $phone)
-		{
-			if ($email) {
-			
-				$query = 'select A.names_ordered, C.id_connection from phpgw_cc_contact A,'.
-				'phpgw_cc_contact_conns B, phpgw_cc_connections C where '.
-				'A.id_contact = B.id_contact and B.id_connection = C.id_connection '.
-				'and B.id_typeof_contact_connection = 1 and '.
-				"A.id_owner ='" .$this->owner."' and C.connection_value = '".$email. "'";
-
-				if (!$this->db->query($query))
-				{	
-					exit ('Query failed! File: '.__FILE__.' on line'.__LINE__);
-				}
-			 
-				$return = false;
-			
-				while($this->db->next_record())
-				{
-					$row = $this->db->row();
-					$return[] =  $row['names_ordered']; 
-				}
-			} 
-			
-			if (!$return && $phone) { 
-
-				$query = 'select A.names_ordered, C.id_connection from phpgw_cc_contact A,'.
-				'phpgw_cc_contact_conns B, phpgw_cc_connections C where '.
-				'A.id_contact = B.id_contact and B.id_connection = C.id_connection '.
-				'and B.id_typeof_contact_connection = 2 and '.
-				"A.id_owner ='" .$this->owner."' and C.connection_value = '".$phone. "'";
-
-				if (!$this->db->query($query))
-				{	
-					exit ('Query failed! File: '.__FILE__.' on line'.__LINE__);
-				}
-			 
-				$return = false;
-			
-				while($this->db->next_record())
-				{
-					$row = $this->db->row();
-					$return[] =  $row['names_ordered']; 
-				}
-
-			}
-			
-			if (!$return && $name) { 
-
-				$query = "select names_ordered, C.id_connection from phpgw_cc_contact where id_owner = '" . $this->owner . "' and RTRIM(names_ordered) = '". $name. "'";
-
-				if (!$this->db->query($query))
-				{	
-					exit ('Query failed! File: '.__FILE__.' on line'.__LINE__);
-				}
-			 
-				$return = false;
-			
-				while($this->db->next_record())
-				{
-					$row = $this->db->row();
-					$return[] =  $row['names_ordered']; 
-				}
-
-			}
-		    $return[] =  $row['id_connection'];
-
-			return $return;
-		}		
-
 		function verifySharedContact($owner,$email)
 		{
@@ -588,5 +554,8 @@
 		function updateContactsByGroup($id_group, $contacts)
 		{
-						
+                        //Atualiza timestamp de status dos contatos afetados
+                        $this -> touchContacts($contacts);
+                        $this -> touchContactsByGroup($id_group);
+                        ///---------------------------------------------------//
 			$query = 'select C.id_connection from phpgw_cc_contact A,'.
 			'phpgw_cc_contact_conns B, phpgw_cc_connections C,phpgw_cc_contact_grps D where '.
@@ -724,4 +693,104 @@
 		}
 		
+		
+		function verifyContact($email, $name, $phone) 
+	 	                { 
+								if($email && $phone && $name){
+								
+									$query = 'select A.names_ordered, C.id_connection from phpgw_cc_contact A,'. 
+	 	                                'phpgw_cc_contact_conns B, phpgw_cc_connections C where '. 
+	 	                                'A.id_contact = B.id_contact and B.id_connection = C.id_connection '. 
+	 	                                'and B.id_typeof_contact_connection = 1 and '. 
+	 	                                "A.id_owner ='" .$this->owner."' and (C.connection_value = '".$email. "' or C.connection_value = '".$phone. "') and RTRIM(A.names_ordered) = '". $name. "'"; 
+								
+									if (!$this->db->query($query)) 
+	 	                                {        
+	 	                                        exit ('Query failed! File: '.__FILE__.' on line'.__LINE__); 
+	 	                                } 
+	 	                          
+	 	                                $return = false; 
+	 	                         
+	 	                                while($this->db->next_record()) 
+	 	                                { 
+	 	                                        $row = $this->db->row(); 
+	 	                                        $return[] =  $row['names_ordered'];  
+	 	                                } 
+								}
+	 	                        if (!$return && $email) { 
+	 	                         
+	 	                                $query = 'select A.names_ordered, C.id_connection from phpgw_cc_contact A,'. 
+	 	                                'phpgw_cc_contact_conns B, phpgw_cc_connections C where '. 
+	 	                                'A.id_contact = B.id_contact and B.id_connection = C.id_connection '. 
+	 	                                'and B.id_typeof_contact_connection = 1 and '. 
+	 	                                "A.id_owner ='" .$this->owner."' and C.connection_value = '".$email. "' and RTRIM(A.names_ordered) = '". $name. "'"; 
+	 	 
+	 	                                if (!$this->db->query($query)) 
+	 	                                {        
+	 	                                        exit ('Query failed! File: '.__FILE__.' on line'.__LINE__); 
+	 	                                } 
+	 	                          
+	 	                                $return = false; 
+	 	                         
+	 	                                while($this->db->next_record()) 
+	 	                                { 
+	 	                                        $row = $this->db->row(); 
+	 	                                        $return[] =  $row['names_ordered'];  
+	 	                                } 
+	 	                        }  	               
+	 	                        if (!$return && $phone) {  
+	 	 
+										$query = 'select A.names_ordered, C.id_connection from phpgw_cc_contact A,'. 
+	 	                                'phpgw_cc_contact_conns B, phpgw_cc_connections C where '. 
+	 	                                'A.id_contact = B.id_contact and B.id_connection = C.id_connection '. 
+	 	                                'and B.id_typeof_contact_connection = 2 and '. 
+	 	                                "A.id_owner ='" .$this->owner."' and C.connection_value = '".$phone. "' and RTRIM(A.names_ordered) = '". $name. "'"; 
+	 	 
+	 	                                if (!$this->db->query($query)) 
+	 	                                {        
+	 	                                        exit ('Query failed! File: '.__FILE__.' on line'.__LINE__); 
+	 	                                } 
+	 	                          
+	 	                                $return = false; 
+	 	                         
+	 	                                while($this->db->next_record()) 
+	 	                                { 
+	 	                                        $row = $this->db->row(); 
+	 	                                        $return[] =  $row['names_ordered'];  
+	 	                                } 
+	 	 
+	 	                        } 
+
+	 	                        if (!$return && $name) {  
+	 	 
+	 	                                $query = "
+										select A.names_ordered, C.id_connection 
+										
+										from phpgw_cc_contact A, 
+											phpgw_cc_contact_conns B, 
+											phpgw_cc_connections C
+										where A.id_contact = B.id_contact and B.id_connection = C.id_connection and
+										B.id_typeof_contact_connection = 2 and
+										A.id_owner = '" . $this->owner . "' and RTRIM(A.names_ordered) = '". $name. "'"; 
+	 	 
+	 	                                if (!$this->db->query($query)) 
+	 	                                {        
+	 	                                        exit ('Query failed! File: '.__FILE__.' on line'.__LINE__); 
+	 	                                } 
+	 	                          
+	 	                                $return = false; 
+	 	                         
+	 	                                while($this->db->next_record()) 
+	 	                                { 
+	 	                                        $row = $this->db->row(); 
+	 	                                        $return[] =  $row['names_ordered'];  
+	 	                                } 
+	 	 
+	 	                        } 
+	 	                    $return[] =  $row['id_connection']; 
+
+	 	                        return $return; 
+	 	                } 
+		
+		
 	}
 ?>
Index: /trunk/contactcenter/inc/class.bo_catalog_group_catalog.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_catalog_group_catalog.inc.php	(revision 3970)
+++ /trunk/contactcenter/inc/class.bo_catalog_group_catalog.inc.php	(revision 5131)
@@ -75,5 +75,5 @@
 			if ($ldap_info = $this->catalog['ldap'])
 			{
-				$meta_catalog =& CreateObject('contactcenter.bo_global_ldap_catalog',$ldap_info['id_source'], $ldap_info['context'], $this->external);
+				$meta_catalog = CreateObject('contactcenter.bo_global_ldap_catalog',$ldap_info['id_source'], $ldap_info['context'], $this->external);
 				return $meta_catalog->find($what, $rules, $other, false, $recursive);
 			}
Index: /trunk/contactcenter/inc/cc_updown.php
===================================================================
--- /trunk/contactcenter/inc/cc_updown.php	(revision 4880)
+++ /trunk/contactcenter/inc/cc_updown.php	(revision 5131)
@@ -2,5 +2,5 @@
 	require_once '../../header.session.inc.php';
 //	This script upload an CSV file to import contacts ....	
-	if($ftmp = $_FILES['import_file']['tmp_name']){				 		
+	if(array_key_exists('import_file', $_FILES) && $ftmp = $_FILES['import_file']['tmp_name']){				 		
 		// Foi necessário modificar o caminho onde se recuperava o diretório temporário.
 		// Esse caminho foi hardcodificado na string abaixo ( /tmp ) temporariamente, mas deve ser recuperada atraves
Index: /trunk/contactcenter/inc/class.bo_global_ldap_catalog.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_global_ldap_catalog.inc.php	(revision 4838)
+++ /trunk/contactcenter/inc/class.bo_global_ldap_catalog.inc.php	(revision 5131)
@@ -127,5 +127,5 @@
 		    }
 
-		    if(!((strlen($find) == 2 && substr($find, -1) == '%') || $find == '%' ))
+		    if(!((strlen($find) == 2 && substr($find, -1) == '%') || $find == '%' ) && !$this->external)
                           return $this->findAddress($find,$other);
 
@@ -160,5 +160,8 @@
 			$ldap = $GLOBALS['phpgw']->common->ldapConnect($this->src_info['host'], $this->src_info['acc'], $this->src_info['pw'], true);
 			$result_r = $recursive ? ldap_search($ldap , $this->src_info['context'], $filter, $fields, 0, $this->src_info['max_results']) :
-			ldap_list($ldap , $this->src_info['context'], $filter, $fields, 0, $this->src_info['max_results']);
+			//Traz apenas 10 resultados,
+			//ldap_list($ldap , $this->src_info['context'], $filter, $fields, 0, $this->src_info['max_results']);
+			//Traz todos os usuários
+			ldap_list($ldap , $this->src_info['context'], $filter, $fields, 0, 0);
 
 			 if (!$result_r)
@@ -350,5 +353,5 @@
 		
 		*/
-		function process_restrictions( $rules, &$trans_table, $join_type='&' )
+		function process_restrictions( &$rules, &$trans_table, $join_type='&' )
 		{
 			if (!is_array($rules) or !count($rules))
@@ -832,9 +835,8 @@
 					case 'connections':
 	                    $preferences = ExecMethod('contactcenter.ui_preferences.get_preferences');
-	                    if (!is_array($preferences))
-	                    {
-							$preferences['personCardEmail'] = 1;
-							$preferences['personCardPhone'] = 2;
-						}
+
+                                                if(!array_key_exists('personCardEmail', $preferences)) $preferences['personCardEmail'] = 1;
+                                                if(!array_key_exists('personCardPhone', $preferences)) $preferences['personCardPhone'] = 2;        		
+                            
 						unset($l_fields);
 				 		$l_fields['connection_name'] = $this->trans_table['contact.connection.connection_name'];
Index: /trunk/contactcenter/inc/class.abo_catalog.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.abo_catalog.inc.php	(revision 4742)
+++ /trunk/contactcenter/inc/class.abo_catalog.inc.php	(revision 5131)
@@ -188,6 +188,6 @@
 		function init()
 		{
-			$this->db =& $GLOBALS['phpgw']->db;
-			$this->security =& CreateObject('contactcenter.security_manager');
+			$this->db = $GLOBALS['phpgw']->db;
+			$this->security = CreateObject('contactcenter.security_manager');
 		}
 
@@ -729,11 +729,11 @@
 						
 					case 'iLIKE':
-						$return_t[] = 'UPPER( '.$associative_tree[$restrict_data['field']]['table'].'.'.
-						              $associative_tree[$restrict_data['field']]['field'].') LIKE UPPER(\''.$restrict_data['value'].'\')';
+						$return_t[] = 'UPPER( translate('.$associative_tree[$restrict_data['field']]['table'].'.'.
+						              $associative_tree[$restrict_data['field']]['field'].',\'áàâãäéèêëíìïóòôõöúùûüÁÀÂÃÄÉÈÊËÍÌÏÓÒÔÕÖÚÙÛÜçÇñÑ\',\'aaaaaeeeeiiiooooouuuuAAAAAEEEEIIIOOOOOUUUUcCnN\')) LIKE UPPER(translate(\''.$restrict_data['value'].'\', \'áàâãäéèêëíìïóòôõöúùûüÁÀÂÃÄÉÈÊËÍÌÏÓÒÔÕÖÚÙÛÜçÇñÑ\',\'aaaaaeeeeiiiooooouuuuAAAAAEEEEIIIOOOOOUUUUcCnN\'))';
 						break;
 					
 					case 'LIKE and ~=':
-						$return_t[] = 'UPPER( to_ascii('.$associative_tree[$restrict_data['field']]['table'].'.'.
-                                      $associative_tree[$restrict_data['field']]['field'].')) LIKE UPPER( to_ascii (\''."%".$restrict_data['value']."%".'\'))';
+					$return_t[] = 'UPPER(translate('.$associative_tree[$restrict_data['field']]['table'].'.'.
+                                      $associative_tree[$restrict_data['field']]['field'].',\'áàâãäéèêëíìïóòôõöúùûüÁÀÂÃÄÉÈÊËÍÌÏÓÒÔÕÖÚÙÛÜçÇñÑ\',\'aaaaaeeeeiiiooooouuuuAAAAAEEEEIIIOOOOOUUUUcCnN\')) LIKE UPPER(translate(\''."%".($restrict_data['value'])."%".'\', \'áàâãäéèêëíìïóòôõöúùûüÁÀÂÃÄÉÈÊËÍÌÏÓÒÔÕÖÚÙÛÜçÇñÑ\',\'aaaaaeeeeiiiooooouuuuAAAAAEEEEIIIOOOOOUUUUcCnN\'))';
 						break;
 					
@@ -883,5 +883,5 @@
 			foreach($id_states as $id_state)
 			{
-				$state =& CreateObject('contactcenter.so_state', $id_state['id_state']);
+				$state = CreateObject('contactcenter.so_state', $id_state['id_state']);
 				
 				$result[$id_state['id_state']]['id_state']   = $state->get_id();
@@ -945,5 +945,5 @@
 			foreach($id_cities as $id_city)
 			{
-				$city =& CreateObject('contactcenter.so_city', $id_city['id_city']);
+				$city = CreateObject('contactcenter.so_city', $id_city['id_city']);
 				
 				$result[$id_city['id_city']]['id_city']      = $city->get_id();
@@ -1035,5 +1035,5 @@
 			}
 
-			$city =& CreateObject('contactcenter.so_city');
+			$city = CreateObject('contactcenter.so_city');
 
 			$city->set_id_country($city_info['id_country']);
@@ -1107,5 +1107,5 @@
 			}
 
-			$state =& CreateObject('contactcenter.so_state');
+			$state = CreateObject('contactcenter.so_state');
 
 			$state->set_id_country($state_info['id_country']);
Index: /trunk/contactcenter/inc/class.bo_people_catalog.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_people_catalog.inc.php	(revision 4502)
+++ /trunk/contactcenter/inc/class.bo_people_catalog.inc.php	(revision 5131)
@@ -608,5 +608,5 @@
 				$added_groups = $groups['added'];
 				$removed_groups = $groups['removed'];
-					
+				if(is_array($added_groups))	
 				foreach ($added_groups as $group)
 				{
@@ -616,5 +616,5 @@
 					$bo_group->add_contacts_in_group($group['id_group'], $c);
 				}
-					
+				if(is_array($removed_groups))	
 				foreach ($removed_groups as $group)
 				{
@@ -1285,4 +1285,5 @@
 			}else{
 				$default =1;
+				if(isset($data['connections']['aditional_phone']))
 				foreach($data['connections']['aditional_phone'] as $connection_name => $connection_fields)
 				{
@@ -1567,4 +1568,5 @@
 					
 					case 'addresses':
+						if(is_array($value))
 						foreach($value as $address_name => $address_fields)
 						{
Index: /trunk/contactcenter/inc/class.ui_api.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.ui_api.inc.php	(revision 4500)
+++ /trunk/contactcenter/inc/class.ui_api.inc.php	(revision 5131)
@@ -48,4 +48,5 @@
 			$template->set_var('cc_msg_err_serialize_data_unknown',lang('Data to be serialized is of unknown type!'));
 			$template->set_var('cc_msg_err_shared',lang('No shared catalog that has permission to add.'));
+			$template->set_var('cc_msg_err_duplicate_group',lang('This group name already exists, please enter another name.'));
 			/* End Messages */
 
@@ -422,5 +423,5 @@
 				}
 				else if ($i == 4){
-					$fieldsHTML .= '<input id="ccQuickAddI'.$i.'" type="text" value="" maxlength="100" style="position: absolute; top: '.($fieldsTop+$i*$fieldsSpace).'px; left: 110px; width: 135px;">'."\n";
+					$fieldsHTML .= '<input id="ccQuickAddI'.$i.'" type="text" value="" onkeyup="emailTolower(\'ccQuickAddI' .$i. '\')" maxlength="100" style="position: absolute; top: '.($fieldsTop+$i*$fieldsSpace).'px; left: 110px; width: 135px;">'."\n";
 				}else if ($i == 3){
 					$fieldsHTML .= '<input id="ccQuickAddI'.$i.'" type="text" value="" onkeyup="formatPhone(this)" maxlength="30" style="position: absolute; top: '.($fieldsTop+$i*$fieldsSpace).'px; left: 110px; width: 135px;">'."\n";
